#!/usr/bin/perl
#
# (c) astx (at) aws-it.at, 2018
#
# $Id: generate_rms_power_dissipation_script.pl 1562 2019-01-06 12:04:33Z sta $
#

use strict;
my $s=0;
my $devs={};
my @lines;

if (! -f "$ARGV[0]") {
	print STDERR "input file <$ARGV[0]> does not exists.\nYou need to call me so: $0 inputfile outputfile\n";
}

open(INP, "< $ARGV[0]") && do {
	while (my $line=<INP>) {
		chomp($line);
		# *==============  Begin SPICE netlist of main design 
		if ($line =~ /^.*Begin SPICE netlist of main design.*/) {
			$s=1;
		}
		if ($s) {
			# known devices:
			my $d=lc($line);
			if ($d=~/^([rdclmq][a-z]*)([0-9]+)\s+/) {
				my $dtyp="$1";
				my $num="$2";
				$devs->{"$dtyp"}{"$num"}=$d;
			}
		}
	}
	close(INP);
};

open(OUT, "> $ARGV[1]") && do {

	foreach my $dtyp (sort keys %{$devs}) {
		foreach my $num (sort {$a<=>$b} keys %{$devs->{$dtyp}}) {
			push(@lines, "$devs->{$dtyp}{$num}");
		}
	}

	print OUT "\n.control\n";

	print OUT "let pwr_steps=vector(x)\n";

	foreach my $line (@lines) {
		my $d=lc($line);
		if ($d=~/^([rdcl][^\s]+)\s+([^\s]+)\s+([^\s]+)\s+/) {
			my $dev="$1";
			print OUT "let pwr_$dev=vector(x)\n";
		}
		if ($d=~/^([mq][^\s]+)\s+([^\s]+)\s+([^\s]+)\s+([^\s]+)\s+/) {
			my $dev=$1;
			print OUT "let pwr_$dev=vector(x)\n";
		}
	}
	print OUT "\n.endc\n\n";
	close(OUT);
};
